package net.rmi.rjs;

// net.rmi.armi.RemoteHelloImplementation;

import gui.In;
import net.rmi.utils.Compile;
import net.rmi.armi.HelloWorld;

import java.io.*;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class RemoteHelloImplementation
        extends UnicastRemoteObject
        implements RemoteHelloInterface {
    HelloWorld hw = new HelloWorld();

    public static void main(String[] args) {
        boolean stubsGenerated = generateStubs();
        System.out.println("generated Stubs");
    }

    private static boolean generateStubs() {
        Compile.rmic(RemoteHelloImplementation.class);
        return true;
    }

    public RemoteHelloImplementation()
            throws RemoteException {
    }

    public void testGetMsg() throws RemoteException {
        hw.testGetMsg();
    }

    public String getMsg() throws RemoteException {
        return hw.getMsg();
    }
    public void putFile(File f) throws RemoteException {
        try {
            FileInputStream fis = new FileInputStream(f);
            final File outputFile = new File(f.getName());
            FileOutputStream fos = new FileOutputStream(outputFile);
            System.out.println("output to:"+outputFile.getAbsolutePath());
            byte b[] = new byte[65563];
            BufferedInputStream bis = new BufferedInputStream(fis,65536);
            int amountRead = 0;
            while ((amountRead = bis.read(b)) != -1) {
                 System.out.println("got some bytes. AmountRead="+amountRead);
                fos.write(b,0,amountRead);
            }
            fos.close();
            fis.close();
        } catch (FileNotFoundException e) {
            In.message(e);

        } catch (IOException e) {
            In.message(e);

        }

    }
    public File getFile(String fileName) throws RemoteException {
         return null;
    }
}

// use the rmic compiler to create a stub
// rmic -v1.2 -d . net.rmi.armi.RemoteHelloImplementation
